#ifndef IS_CTR_MEDIAFILER_LIB_H_
#define IS_CTR_MEDIAFILER_LIB_H_

namespace is { namespace mediafiler {

// AP[^
typedef void* (*Alloc)(size_t size, s32 alignment);
typedef void  (*Free)(void* p);

// R[obN
struct CallbackArgs
{
	// ^Cv
	enum Type
	{
        READ,					// CTR  PC փt@CRs[
        WRITE,					// PC  CTR փt@CRs[
        CREATE,					// CTR ɐVKt@C or tH_𐶐
        DELETE,					// CTR ̃t@C or tH_폜
        RENAME					// CTR ̃t@C or tH_l[
	};

	// ϐ
	Type			m_type;			// ^Cv
	bool			m_isDirectory;	// ΏۂfBNg
	NN_PADDING2;
    const wchar_t*	m_fileName;		// Ώۃt@C
    const wchar_t*	m_oldName;		// RENAMÊݎgpBȊONULLB
};
typedef void (*CallbackFunction)(void* userArgs, const CallbackArgs* callbackArgs);

// {CugpOɂ͕K
// nn::hio::CTR::InitializesĂB

// Cu܂B
// CułȂꍇfalseԂ܂B
// transferBufferSizẽftHgl͏ȃݒ(4 * 1024)łB
// ɗ]TꍇA傫ȃt@C]ꍇɂ
// 256 * 1024A1024 * 1024Ȃǂ̑傫2ׂ̂̒lw肷ƃt@C̓]x荂ɂȂ܂B
// transferBufferSize2ׂ̂ȊOw肳ꂽꍇfalseԂ܂B
bool Initialize(Alloc allocFromMainMemory, Free freeFromMainMemory, Alloc allocFromDeviceMemory, Free freeFromDeviceMemory, size_t transferBufferSize = 4 * 1024);

// gZ[uf[^IDݒ肵܂B
// ftHgl0xff3ffłB
void SetExtSaveDataId(nn::fs::ExtSaveDataId id);

// PC ̃t@C삪ɌĂяoR[obN֐o^܂B
void SetCallback(CallbackFunction function, void* userArgs);

// T[o[Jn܂B
// T[o[JnłȂꍇfalseԂ܂B
// {Cuł͂̊֐ȊOł̓̊mۂ͍s܂B
bool StartServer();

// T[o[I܂B
void EndServer();

// CuI܂B
void Finalize();

}}

#endif
